/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as
 *  published by the Free Software Foundation; either version 2.1
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *  MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */


#include <config.h>
#include "g2mpls_addr.h"
#include "g2mpls_types.h"

#if HAVE_OMNIORB

#ifdef __cplusplus

#include "types.hh"
#include "g2mplsTypes.hh"

using namespace std;

#include <omniORB4/CORBA.h>

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <stdexcept>
#include <sstream>
#include <iomanip>

// nodeId
g2mpls_addr_t &
operator << (g2mpls_addr_t &                     dst,
	     const g2mplsTypes::nodeId &         src);

g2mplsTypes::nodeId &
operator << (g2mplsTypes::nodeId &               dst,
	     const g2mpls_addr_t &               src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::nodeId &         src);


// linkId
g2mpls_addr_t &
operator << (g2mpls_addr_t &                     dst,
	     const g2mplsTypes::linkId_var &     src);

g2mplsTypes::linkId_var &
operator << (g2mplsTypes::linkId_var &           dst,
	     const g2mpls_addr_t &               src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::linkId_var &     src);

bool
operator == (const g2mpls_addr_t &               dst,
	     const g2mplsTypes::linkId_var &     src);

// labelId
label_id_t &
operator<< (label_id_t &                         dst,
	    const g2mplsTypes::labelId_var &     src);

g2mplsTypes::labelId_var &
operator<< (g2mplsTypes::labelId_var &           dst,
	    const label_id_t &                   src);

std::string &
operator<< (std::string &                        dst,
	    const g2mplsTypes::labelId_var &     src);

// xcDirection
xcdirection_t &
operator<< (xcdirection_t &                      dst,
	    const g2mplsTypes::xcDirection &     src);

g2mplsTypes::xcDirection &
operator<< (g2mplsTypes::xcDirection &           dst,
	    const xcdirection_t &                src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::xcDirection &    src);

// tnrcResult
std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::tnrcResult &     src);

// adjType
adj_type_t &
operator << (adj_type_t &                        dst,
	     const g2mplsTypes::adjType &        src);

g2mplsTypes::adjType &
operator << (g2mplsTypes::adjType &              dst,
	     const adj_type_t &                  src);
bool
operator == (const adj_type_t &                  dst,
	     const g2mplsTypes::adjType &        src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::adjType &        src);

// operState
opstate_t &
operator << (opstate_t &                         dst,
	     const g2mplsTypes::operState &      src);

g2mplsTypes::operState &
operator << (g2mplsTypes::operState &            dst,
	     const opstate_t &                   src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::operState &      src);

// adminState
admstate_t &
operator << (admstate_t &                        dst,
	     const g2mplsTypes::adminState &     src);

g2mplsTypes::adminState &
operator << (g2mplsTypes::adminState &           dst,
	     const admstate_t &                  src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::adminState &     src);

// switchingCap
sw_cap_t &
operator << (sw_cap_t &                          dst,
	     const g2mplsTypes::switchingCap &   src);

g2mplsTypes::switchingCap &
operator << (g2mplsTypes::switchingCap &         dst,
	     const sw_cap_t  &                   src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::switchingCap &   src);

// encodingType
enc_type_t &
operator << (enc_type_t &                        dst,
	     const g2mplsTypes::encodingType &   src);

g2mplsTypes::encodingType &
operator << (g2mplsTypes::encodingType &         dst,
	     const enc_type_t &                  src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::encodingType &   src);

// labelState
label_state_t &
operator << (label_state_t &                     dst,
	     const g2mplsTypes::labelState &     src);

g2mplsTypes::labelState &
operator << (g2mplsTypes::labelState &           dst,
	     const label_state_t &               src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::labelState &     src);

// sourceId
g2mpls_addr_t &
operator<<(g2mpls_addr_t &                          dst,
	   const g2mplsTypes::sourceId_var &        src);

g2mplsTypes::sourceId_var &
operator<<(g2mplsTypes::sourceId_var &              dst,
	   const g2mpls_addr_t &                    src);

std::string &
operator<<(std::string &                            dst,
	   const g2mplsTypes::sourceId_var &        src);


// tnaId
g2mpls_addr_t &
operator<<(g2mpls_addr_t &                          dst,
	   const g2mplsTypes::tnaId_var &           src);

g2mplsTypes::tnaId_var &
operator<<(g2mplsTypes::tnaId_var &                 dst,
	   const g2mpls_addr_t &                    src);

std::string &
operator<<(std::string &                            dst,
	   const g2mplsTypes::tnaId_var &           src);

// gridHostId
g2mpls_addr_t &
operator<<(g2mpls_addr_t &                          dst,
	   const g2mplsTypes::gridHostId_var &      src);

g2mplsTypes::gridHostId_var &
operator<<(g2mplsTypes::gridHostId_var &            dst,
	   const g2mpls_addr_t &                    src);

std::string &
operator<<(std::string &                            dst,
	   const g2mplsTypes::gridHostId_var &      src);


// labelId
label_id_t &
operator<<(label_id_t &                             dst,
	   const g2mplsTypes::labelId_var &         src);

g2mplsTypes::labelId_var &
operator<<(g2mplsTypes::labelId_var &               dst,
	   const label_id_t &                       src);

std::string &
operator<<(std::string &                            dst,
	   const g2mplsTypes::labelId_var &         src);

// callIdent
call_ident_t &
operator<<(call_ident_t &                           dst,
	   const g2mplsTypes::callIdent_var &       src);

g2mplsTypes::callIdent_var &
operator<<(g2mplsTypes::callIdent_var &             dst,
	   const call_ident_t &                     src);

// tnResource
net_res_spec_t &
operator<<(net_res_spec_t &                         dst,
	   const g2mplsTypes::tnResource_var &      src);

g2mplsTypes::tnResource_var &
operator<<(g2mplsTypes::tnResource_var &            dst,
	   const net_res_spec_t &                   src);

// tnaResource
net_res_spec_t &
operator<<(net_res_spec_t &                         dst,
	   const g2mplsTypes::tnaResource_var &     src);

g2mplsTypes::tnaResource_var &
operator<<(g2mplsTypes::tnaResource_var &           dst,
	   const net_res_spec_t &                   src);

// gridParams
grid_res_spec_t &
operator<<(grid_res_spec_t &                        dst,
	   const g2mplsTypes::gridParams_var &      src);

g2mplsTypes::gridParams_var &
operator<<(g2mplsTypes::gridParams_var &            dst,
	   const grid_res_spec_t &                  src);

// callParams
call_info_t &
operator<<(call_info_t &                            dst,
	   const g2mplsTypes::callParams_var &      src);

g2mplsTypes::callParams_var &
operator<<(g2mplsTypes::callParams_var &            dst,
	   const call_info_t &                      src);

// recoveryParams
recovery_info_t &
operator<<(recovery_info_t &                        dst,
	   const g2mplsTypes::recoveryParams_var &  src);

g2mplsTypes::recoveryParams_var &
operator<<(g2mplsTypes::recoveryParams_var &        dst,
	   const recovery_info_t &                  src);

// lspIdent
lsp_ident_t &
operator<<(lsp_ident_t &                            dst,
	   const g2mplsTypes::lspIdent_var &        src);

g2mplsTypes::lspIdent_var &
operator<<(g2mplsTypes::lspIdent_var &              dst,
	   const lsp_ident_t &                      src);

// lspParams
lsp_info_t &
operator<<(lsp_info_t &                             dst,
	   const g2mplsTypes::lspParams_var &       src);

g2mplsTypes::lspParams_var &
operator<<(g2mplsTypes::lspParams_var &             dst,
	   const lsp_info_t &                       src);

// wdmLambdasBitmap
wdm_link_lambdas_bitmap_t &
operator<<(wdm_link_lambdas_bitmap_t &               dst,
	   const g2mplsTypes::wdmLambdasBitmap_var & src);

g2mplsTypes::wdmLambdasBitmap_var &
operator<<(g2mplsTypes::wdmLambdasBitmap_var &      dst,
	   const wdm_link_lambdas_bitmap_t &        src);

// errorInfo
error_info_t &
operator<<(error_info_t &                           dst,
	   const g2mplsTypes::errorInfo_var &       src);

g2mplsTypes::errorInfo_var &
operator<<(g2mplsTypes::errorInfo_var &             dst,
	   const error_info_t &                     src);


#endif // __cplusplus

#endif // HAVE_OMNIORB
