//
//  This file is part of phosphorus-g2mpls.
//
//  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed const the hope that it will be useful,
//  but WITHANY WARRANTY; witheven the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklconst Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//  Authors:
//
//  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
//  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
//  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
//  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
//  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
//

#ifndef __G2PCERA_CORBA_UTILS_HH__
#define __G2PCERA_CORBA_UTILS_HH__

#if HAVE_OMNIORB

#include "g2pcera_config.hh"
#include "g2pcera_common.hh"
#include "g2pcera_corba.hh"

#ifdef __cplusplus

#include "log.h"
#include "idl/types.hh"
#include "idl/g2mplsTypes.hh"

using namespace std;

#include <omniORB4/CORBA.h>

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <stdexcept>
#include <sstream>
#include <iomanip>

// nodeIdent
node_ident_t &
operator << (node_ident_t &                     dst,
	     const g2mplsTypes::nodeIdent_var & src);

g2mplsTypes::nodeIdent_var &
operator << (g2mplsTypes::nodeIdent_var &       dst,
	     const node_ident_t &               src);

std::string &
operator << (std::string &                       dst,
	     const g2mplsTypes::nodeIdent_var &  src);

// gridSubNodeIdent
grid_subnode_ident_t &
operator << (grid_subnode_ident_t &                    dst,
	     const g2mplsTypes::gridSubNodeIdent_var & src);

g2mplsTypes::gridSubNodeIdent_var &
operator << (g2mplsTypes::gridSubNodeIdent_var &       dst,
	     const grid_subnode_ident_t &              src);

std::string &
operator << (std::string &                             dst,
	     const g2mplsTypes::gridSubNodeIdent_var & src);

// teLinkIdent
telink_ident_t &
operator << (telink_ident_t &                     dst,
	     const g2mplsTypes::teLinkIdent_var & src);

g2mplsTypes::teLinkIdent_var &
operator << (g2mplsTypes::teLinkIdent_var &       dst,
	     const telink_ident_t &               src);

std::string &
operator << (std::string &                        dst,
	     const g2mplsTypes::teLinkIdent_var & src);

// tnaIdent
tna_ident_t &
operator << (tna_ident_t &                     dst,
	     const g2mplsTypes::tnaIdent_var & src);

g2mplsTypes::tnaIdent_var &
operator << (g2mplsTypes::tnaIdent_var &       dst,
	     const tna_ident_t &               src);

std::string &
operator << (std::string &                     dst,
	     const g2mplsTypes::tnaIdent_var & src);

// netNodeParams
net_node_data_t &
operator << (net_node_data_t &                      dst,
	     const g2mplsTypes::netNodeParams_var & src);

g2mplsTypes::netNodeParams_var &
operator << (g2mplsTypes::netNodeParams_var &   dst,
	     const net_node_data_t &            src);

// gridSiteParams
grid_site_data_t &
operator << (grid_site_data_t &                      dst,
	     const g2mplsTypes::gridSiteParams_var & src);

g2mplsTypes::gridSiteParams_var &
operator << (g2mplsTypes::gridSiteParams_var &   dst,
	     const grid_site_data_t &            src);

// gridSubNodes
grid_subnodes_t &
operator << (grid_subnodes_t &                     dst,
	     const g2mplsTypes::gridSubNodes_var & src);

g2mplsTypes::gridSubNodes_var &
operator << (g2mplsTypes::gridSubNodes_var & dst,
	     const grid_subnodes_t &         src);

// gridHostId
g2mpls_addr_t &
operator<<(g2mpls_addr_t &                          dst,
	   const g2mplsTypes::gridHostId_var &      src);

g2mplsTypes::gridHostId_var &
operator<<(g2mplsTypes::gridHostId_var &            dst,
	   const g2mpls_addr_t &                    src);

std::string &
operator<<(std::string &                            dst,
	   const g2mplsTypes::gridHostId_var &      src);

// gridServiceState
grid_service_state_t &
operator<<(grid_service_state_t &                   dst,
	   const g2mplsTypes::gridServiceState &    src);

g2mplsTypes::gridServiceState &
operator<<(g2mplsTypes::gridServiceState &          dst,
	   const grid_service_state_t &             src);


// gridServiceInfo
grid_service_info_t &
operator<<(grid_service_info_t &                    dst,
	   const g2mplsTypes::gridServiceInfo_var & src);

g2mplsTypes::gridServiceInfo_var &
operator<<(g2mplsTypes::gridServiceInfo_var &       dst,
	   const grid_service_info_t &              src);

// gridServiceParams
grid_service_data_t &
operator << (grid_service_data_t &                      dst,
	     const g2mplsTypes::gridServiceParams_var & src);

g2mplsTypes::gridServiceParams_var &
operator << (g2mplsTypes::gridServiceParams_var &   dst,
	     const grid_service_data_t &            src);

// gridLrmsInfo
grid_lrms_info_t &
operator<<(grid_lrms_info_t &                      dst,
	   const g2mplsTypes::gridLrmsInfo_var &   src);

g2mplsTypes::gridLrmsInfo_var &
operator<<(g2mplsTypes::gridLrmsInfo_var &         dst,
	   const grid_lrms_info_t &                src);

// gridJobsState
grid_jobs_state_t &
operator<<(grid_jobs_state_t &                      dst,
	   const g2mplsTypes::gridJobsState_var &   src);

g2mplsTypes::gridJobsState_var &
operator<<(g2mplsTypes::gridJobsState_var &         dst,
	   const grid_jobs_state_t &                src);

// gridJobsStats
grid_jobs_stats_t &
operator<<(grid_jobs_stats_t &                      dst,
	   const g2mplsTypes::gridJobsStats_var &   src);

g2mplsTypes::gridJobsStats_var &
operator<<(g2mplsTypes::gridJobsStats_var &         dst,
	   const grid_jobs_stats_t &                src);

// gridJobsTimePerf
grid_jobs_time_perf_t &
operator<<(grid_jobs_time_perf_t &                     dst,
	   const g2mplsTypes::gridJobsTimePerf_var &   src);

g2mplsTypes::gridJobsTimePerf_var &
operator<<(g2mplsTypes::gridJobsTimePerf_var &         dst,
	   const grid_jobs_time_perf_t &               src);

// gridJobsTimePolicy
grid_jobs_time_policy_t &
operator<<(grid_jobs_time_policy_t &                    dst,
	   const g2mplsTypes::gridJobsTimePolicy_var &  src);

g2mplsTypes::gridJobsTimePolicy_var &
operator<<(g2mplsTypes::gridJobsTimePolicy_var &        dst,
	   const grid_jobs_time_policy_t &              src);

// gridJobsLoadpolicy
grid_jobs_load_policy_t &
operator<<(grid_jobs_load_policy_t &                    dst,
	   const g2mplsTypes::gridJobsLoadPolicy_var &  src);

g2mplsTypes::gridJobsLoadPolicy_var &
operator<<(g2mplsTypes::gridJobsLoadPolicy_var &        dst,
	   const grid_jobs_load_policy_t &              src);

// gridCEParams
grid_ce_data_t &
operator << (grid_ce_data_t &                      dst,
	     const g2mplsTypes::gridCEParams_var & src);

g2mplsTypes::gridCEParams_var &
operator << (g2mplsTypes::gridCEParams_var &   dst,
	     const grid_ce_data_t &            src);

// gridCpuInfo
grid_cpu_info_t &
operator<<(grid_cpu_info_t &                      dst,
	   const g2mplsTypes::gridCpuInfo_var &   src);

g2mplsTypes::gridCpuInfo_var &
operator<<(g2mplsTypes::gridCpuInfo_var &         dst,
	   const grid_cpu_info_t &                src);

// gridOsInfo
grid_os_info_t &
operator<<(grid_os_info_t &                      dst,
	   const g2mplsTypes::gridOsInfo_var &   src);

g2mplsTypes::gridOsInfo_var &
operator<<(g2mplsTypes::gridOsInfo_var &         dst,
	   const grid_os_info_t &                src);

// gridMemoryInfo
grid_memory_info_t &
operator<<(grid_memory_info_t &                      dst,
	   const g2mplsTypes::gridMemoryInfo_var &   src);

g2mplsTypes::gridMemoryInfo_var &
operator<<(g2mplsTypes::gridMemoryInfo_var &         dst,
	   const grid_memory_info_t &                src);

// gridApplication
grid_application_t &
operator<<(grid_application_t &                      dst,
	   const g2mplsTypes::gridApplication_var &   src);

g2mplsTypes::gridApplication_var &
operator<<(g2mplsTypes::gridApplication_var &         dst,
	   const grid_application_t &                src);

// gridSubClusterParams
grid_subcluster_data_t &
operator << (grid_subcluster_data_t &                      dst,
	     const g2mplsTypes::gridSubClusterParams_var & src);

g2mplsTypes::gridSubClusterParams_var &
operator << (g2mplsTypes::gridSubClusterParams_var &   dst,
	     const grid_subcluster_data_t &            src);


// gridStorageInfo
grid_storage_info_t &
operator<<(grid_storage_info_t &                      dst,
	   const g2mplsTypes::gridStorageInfo_var &   src);

g2mplsTypes::gridStorageInfo_var &
operator<<(g2mplsTypes::gridStorageInfo_var &         dst,
	   const grid_storage_info_t &                src);

// gridStorageAreaInfo
grid_storage_area_info_t &
operator<<(grid_storage_area_info_t &                     dst,
	   const g2mplsTypes::gridStorageAreaInfo_var &   src);

g2mplsTypes::gridStorageAreaInfo_var &
operator<<(g2mplsTypes::gridStorageAreaInfo_var &         dst,
	   const grid_storage_area_info_t &               src);

// gridSEParams
grid_se_data_t &
operator << (grid_se_data_t &                      dst,
	     const g2mplsTypes::gridSEParams_var & src);

g2mplsTypes::gridSEParams_var &
operator << (g2mplsTypes::gridSEParams_var &   dst,
	     const grid_se_data_t &            src);

// teLinkComParams
telink_com_data_t &
operator << (telink_com_data_t &                      dst,
	     const g2mplsTypes::teLinkComParams_var & src);

g2mplsTypes::teLinkComParams_var &
operator << (g2mplsTypes::teLinkComParams_var &       dst,
	     const telink_com_data_t &                src);

// teLinkTdmParams
telink_tdm_data_t &
operator << (telink_tdm_data_t &                      dst,
	     const g2mplsTypes::teLinkTdmParams_var & src);

g2mplsTypes::teLinkTdmParams_var &
operator << (g2mplsTypes::teLinkTdmParams_var &       dst,
	     const telink_tdm_data_t &                src);

// teLinkLscG709Params
telink_lscg709_data_t &
operator << (telink_lscg709_data_t &                      dst,
	     const g2mplsTypes::teLinkLscG709Params_var & src);

g2mplsTypes::teLinkLscG709Params_var &
operator << (g2mplsTypes::teLinkLscG709Params_var &       dst,
	     const telink_lscg709_data_t &                src);

// teLinkLscWdmParams
telink_lscwdm_data_t &
operator << (telink_lscwdm_data_t &                      dst,
	     const g2mplsTypes::teLinkLscWdmParams_var & src);

g2mplsTypes::teLinkLscWdmParams_var &
operator << (g2mplsTypes::teLinkLscWdmParams_var &   dst,
	     const telink_lscwdm_data_t &            src);


// isc
isc_t &
operator << (isc_t &                      dst,
	     const g2mplsTypes::isc_var & src);

g2mplsTypes::isc_var &
operator << (g2mplsTypes::isc_var &   dst,
	     const isc_t &            src);

// eroItem
ero_hop_t &
operator << (ero_hop_t &                      dst,
	     const g2mplsTypes::eroItem_var & src);

g2mplsTypes::eroItem_var &
operator << (g2mplsTypes::eroItem_var &       dst,
	     const ero_hop_t &                src);

// connEndPoint
ero_hop_t &
operator << (ero_hop_t &                           dst,
	     const g2mplsTypes::connEndPoint_var & src);

g2mplsTypes::connEndPoint_var &
operator << (g2mplsTypes::connEndPoint_var &       dst,
	     const ero_hop_t &                     src);

// wdmLambdasBitmap
wdm_link_lambdas_bitmap_t &
operator<<(wdm_link_lambdas_bitmap_t &               dst,
	   const g2mplsTypes::wdmLambdasBitmap_var & src);

g2mplsTypes::wdmLambdasBitmap_var &
operator<<(g2mplsTypes::wdmLambdasBitmap_var &  dst,
	   const wdm_link_lambdas_bitmap_t &    src);

// gridParams
grid_res_spec_t &
operator<<(grid_res_spec_t &               dst,
	   const g2mplsTypes::gridParams & src);

// callParams
call_info_t & operator<<(call_info_t &                    dst,
			 const g2mplsTypes::callParams &  src);

#endif // __cplusplus

#endif // HAVE_OMNIORB

#endif // __G2PCERA_CORBA_UTILS_HH__
