//
//  This file is part of phosphorus-g2mpls.
//
//  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//  Authors:
//
//  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
//  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
//  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
//  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
//  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
//



#ifndef __G2PCERA_DUMP_HH__
#define __G2PCERA_DUMP_HH__

#include "g2pcera_common.hh"

//
// log dump policy
//
void		logDump(const std::string &		prefix,
			const call_ident_t &		cid);
void		logDump(const std::string &		prefix,
			const lsp_ident_t &		lid);
void		logDump(const std::string &		prefix,
			const net_res_spec_t &		res);
void		logDump(const std::string &		prefix,
			const res_spec_t &		res);
void		logDump(const std::string &		prefix,
			const call_info_t &		cdata);
void		logDump(const std::string &		prefix,
			const recovery_info_t &		rdata);
void		logDump(const std::string &		prefix,
			const lsp_info_t &		ldata);
void		logDump(const std::string &		prefix,
			const ero_hop_t &		hop);

void		logDump(const std::string &		prefix,
			const topology_summary_data_t &	data);
void		logDump(const std::string &		prefix,
			const node_ident_t &		data);
void		logDump(const std::string &		prefix,
			const net_node_data_t &		data);
void		logDump(const std::string &		prefix,
			const grid_site_data_t &	data);
void		logDump(const std::string &		prefix,
			const grid_subnode_ident_t &	data);
void		logDump(const std::string &		prefix,
			const grid_service_data_t &	data);
void		logDump(const std::string &		prefix,
			const grid_ce_data_t &		data);
void		logDump(const std::string &		prefix,
			const grid_subcluster_data_t &	data);
void		logDump(const std::string &		prefix,
			const grid_se_data_t &		data);
void		logDump(const std::string &		prefix,
			const tna_ident_t &		ident);
void		logDump(const std::string &		prefix,
			const telink_ident_t &		ident);
void		logDump(const std::string &		prefix,
			const telink_com_data_t &	data);
void		logDump(const std::string &		prefix,
			const opstate_t &		op,
			const admstate_t &		adm);
void		logDump(const std::string &		prefix,
			const std::list<isc_t> &	iscs);
void		logDump(const std::string &		prefix,
			const bw_per_prio_t &		bw);
void		logDump(const std::string &		prefix,
			const std::list<uint32_t> &	ll,
			bool				isTdm,
			bool				isG709ODUk,
			bool				isG709OCh);
void		logDump(const std::string &				prefix,
			const std::map<uint32_t, bw_per_prio_t> &	cal);
void		logDump(const std::string &		prefix,
			const telink_psc_data_t &	data);
void		logDump(const std::string &		prefix,
			const telink_tdm_data_t &	data);
void		logDump(const std::string &		prefix,
			const telink_lscg709_data_t &	data);
void		logDump(const std::string &		prefix,
			const telink_lscwdm_data_t &	data);
void		logDump(const std::string &			prefix,
			const wdm_link_lambdas_bitmap_t &	data);



//
// VTY dump policy
//
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const call_ident_t &		cid);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const lsp_ident_t &		lid);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const net_res_spec_t &		res);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const res_spec_t &		res);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const call_info_t &		cdata);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const recovery_info_t &		rdata);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const lsp_info_t &		ldata);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const ero_hop_t &		hop);

void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const topology_summary_data_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const node_ident_t &		data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const net_node_data_t &		data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const grid_site_data_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const grid_subnode_ident_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const grid_service_data_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const grid_ce_data_t &		data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const grid_subcluster_data_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const grid_se_data_t &		data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const tna_ident_t &		ident);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const telink_ident_t &		ident);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const telink_com_data_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const opstate_t &		op,
			const admstate_t &		adm);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const std::list<isc_t> &	iscs);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const bw_per_prio_t &		bw);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const std::list<uint32_t> &	ll,
			bool				isTdm,
			bool				isG709ODUk,
			bool				isG709OCh);
void		vtyDump(struct vty *					vty,
			const std::string &				prefix,
			const std::map<uint32_t, bw_per_prio_t> &	cal);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const telink_psc_data_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const telink_tdm_data_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const telink_lscg709_data_t &	data);
void		vtyDump(struct vty *			vty,
			const std::string &		prefix,
			const telink_lscwdm_data_t &	data);
void		vtyDump(struct vty *				vty,
			const std::string &			prefix,
			const wdm_link_lambdas_bitmap_t &	data);

#endif // __G2PCERA_DUMP_HH__
