/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef __G2RSVP_COMMON_TYPES_H__
#define __G2RSVP_COMMON_TYPES_H__

#include <g2mpls_types.h>
#include <g2mpls_addr.h>
#include <string>

#include "g2rsvpte_message_objects.h"

#define SHOW_LSPIDENT(X)						\
	G2RSVPTE_DBG("LSP ID:        %d", X.lsp_id);			\
	G2RSVPTE_DBG("  src node id: %s", numb_htoa(X.src_nid));	\
	G2RSVPTE_DBG("  dst node id: %s", numb_htoa(X.dst_nid));	\
	G2RSVPTE_DBG("  tunnel id:   %d", X.tun_id);			\
	G2RSVPTE_DBG("  ext tun id:  %d", X.ext_tun_id);

bool operator==(lsp_ident_t src, lsp_ident_t dst);
bool operator==(lsp_ero_sobj_t src, lsp_ero_sobj_t dst);

std::string hop2string(const lsp_ero_sobj_t & sobj);

RSVP::Label_Class * &
operator << (RSVP::Label_Class * & dst, const label_id_t & src);

label_id_t &
operator << (label_id_t & dst, const RSVP::Label_Class * src);

#endif /* __G2RSVP_COMMON_TYPES_H__ */
