/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef G2RSVPTE_CONFIG_H
#define G2RSVPTE_CONFIG_H

#define G2RSVPTED_DEFAULT_CONFIG "/usr/local/etc/g2rsvpted.conf"
#define G2RSVPTED_VTY_PORT       2630
#define G2RSVPTE_VERSION            2     // RSVP Protocol Version
#define G2RSVPTE_CODE_VERSION    "0.1"    // RSVPd Code Version

#define LSP_FSM_TIMER             80      // seconds
#define MAX_CBACK_RETRIES_ATTEMPTS 3

//#define PATH_G2RSVPTED_PID     "/usr/local/quagga-0.99.7/etc/rsvpd.pid"
//#define G2RSVPTE_VTYSH_PATH    "/var/run/rsvpd.vty"


#define CRANKBACK_ON
#define PERSISTENCY_ON

//
// For debugging
//

//#define G2RSVPTE2LRM_DEBUG       // USEFUL for testing G2RSVPTE without LRM
//#define G2RSVPTE2TNRC_DEBUG      // USEFUL for testing G2RSVPTE without TNRC
//#define G2RSVPTE2SCNGW_DEBUG     // USEFUL for testing G2RSVPTE without SCNGW
//#define G2RSVPTE2RC_DEBUG        // USEFUL for testing G2RSVPTE without RC
//#define G2RSVPTE2CC_DEBUG        // USEFUL for testing G2RSVPTE without CC
//#define G2RSVPTE2PC_DEBUG        // USEFUL for testing G2RSVPTE without PC

//#define VERBOSE_DEBUG

#endif // G2RSVPTE_CONFIG_H
