/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef __G2RSVPTE_LRM_APIS_H__
#define __G2RSVPTE_LRM_APIS_H__

#include <stdint.h>

#include "g2mpls_types.h"
#include "g2mpls_addr.h"
#include "g2rsvpted/g2rsvpte_dm.h"


//VERY TMP!!!!!!
#define SRC "192.168.90.153"
#define DST "192.168.90.160"

#define ROUTERID1 "10.10.10.1"
#define ITNA      "1.1.1.1"  // iTNA
#define LOCALID2  SRC
#define REMOTEID2 DST

#define ETNA      "1.1.1.4"  // eTNA
#define ROUTERID2 "10.10.10.2"

bool getLocDLid_on_remDLid(uint32_t        nodeId,
			   g2mpls_addr_t   remoteDL,
			   g2mpls_addr_t & localDL,
			   admstate_t &    adminStatus,
			   opstate_t &     operStatus);

RSVP::Interface * getTELink_on_DLid(RSVP::G2RSVPTE * instance,
				    g2mpls_addr_t    localDL);

bool getDL_Label_on_TELink(g2mpls_addr_t intf,
			   // .... , TODO add params
			   g2mpls_addr_t &   dsDL,
			   uint32_t &        dsTxLbl);

bool getDL_checkLabel_on_TELink(g2mpls_addr_t   TELink,
				uint32_t        lbl,
				g2mpls_addr_t & dl);

// return false if teLink is not present
bool checkTELink(g2mpls_addr_t teLink);

bool getTELinkfromTna(g2mpls_addr_t tna, g2mpls_addr_t & teLink);

bool getTELinkfromRemNodeId(uint32_t node, g2mpls_addr_t & teLink);

bool getRouterId(uint32_t & routerId);

typedef struct {
	g2mpls_addr_t localId;
	g2mpls_addr_t remoteId;
	uint32_t      neighbourId;
	opstate_t     op_state;
	admstate_t    adm_state;
} Interface_data_t;

bool getInterfaces(uint32_t routerId,
		   std::list<Interface_data_t> & intfs,
		   adj_type_t adjType);

#endif // __G2RSVPTE_LRM_APIS_H__
