/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef G2RSVPTE_LSP_H
#define G2RSVPTE_LSP_H

#include <iostream>
#include <stdio.h>

#include "g2rsvpte_dm.h"
#include "g2rsvpte_lsp_gen.h"
#include "g2rsvpte_messages.h"

typedef struct {
	RSVP::LSP *       lsp;
	RSVP::Interface * intf;   // ???
	RSVP::Message *   msg;
} G2RSVPTE_LSP_FSM_context_t;

typedef struct {
	RSVP::LSP *       lsp;
	adj_type_t        adjType;
} G2RSVPTE_LSP_TIMER_context_t;

class WaitResvConf_i : public fsm::base_G2RSVPTE_LSP_FSM::WaitResvConf {

 public:
	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResv_t RecvResv(void* context);

	void after_evRecvResvKo_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathErr_t RecvPathErr(void* context);

	void after_evRecvPathErrKo_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPath_t RecvPath(void* context);

	void after_evRecvPathOk_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTimer_t RecvResvTimer(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnPreempt_t XConnPreempt(void* context);

	void after_evXConnPreempt_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathTear_t SendPathTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendConfirm_t SendConfirm(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvConfirm_t RecvConfirm(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathDown_t RecvPathDown(void* context);

	void after_evRecvPathDownKo_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTear_t RecvResvTear(void* context);

	void after_evRecvResvTearKo_from_virt_WaitResvConf(void * context);

	void after_evRecvPathKo_from_virt_WaitResvConf(void * context);

	void after_evRecvConfirmKo_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvTear_t SendResvTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvErr_t RecvResvErr(void* context);

	void after_evRecvResvErrKo_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTear_t RecvPathTear(void* context);

	void after_evRecvPathTearKo_from_virt_WaitResvConf(void * context);

	void after_evRecvResvErrOk_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimer_t RecvPathTimer(void* context);

	void after_evRecvResvOk_from_virt_WaitResvConf(void * context);

	void after_evRecvResvOk_from_virt_WaitResv(void * context);

	void after_evSendResv_from_virt_WaitResv(void * context);

	void after_evXConnCompleted_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathDown_t SendPathDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvDown_t RecvResvDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvDown_t SendResvDown(void* context);

	void after_evRecvResvDownKo_from_virt_WaitResvConf(void * context);

};

class WaitResv_i : public fsm::base_G2RSVPTE_LSP_FSM::WaitResv {

 public:

	void after_evRecvResvTimer_from_virt_WaitResvConf(void * context);

	void after_evRecvPathTimer_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimeout_t RecvPathTimeout(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResv_t RecvResv(void* context);

	void after_evRecvResvKo_from_virt_WaitResv(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathErr_t RecvPathErr(void* context);

	void after_evRecvPathErrKo_from_virt_WaitResv(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPath_t RecvPath(void* context);

	void after_evRecvPathOk_from_virt_WaitResv(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnPreempt_t XConnPreempt(void* context);

	void after_evXConnPreempt_from_virt_WaitResv(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathTear_t SendPathTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTear_t RecvResvTear(void* context);

	void after_evRecvResvTearKo_from_virt_WaitResv(void * context);

	void after_evRecvPathKo_from_virt_WaitResv(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvTear_t SendResvTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTear_t RecvPathTear(void* context);

	void after_evRecvPathTearKo_from_virt_WaitResv(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimer_t RecvPathTimer(void* context);

	void after_evRecvPathTimer_from_virt_WaitResv(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResv_t SendResv(void* context);

	void after_evXConnCompleted_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathDown_t SendPathDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathDown_t RecvPathDown(void* context);

	void after_evRecvPathDownKo_from_virt_WaitResv(void * context);

	void after_evRecvResvDownKo_from_virt_WaitResv(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvDown_t SendResvDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvDown_t RecvResvDown(void* context);

};

class WaitEqptConf_i : public fsm::base_G2RSVPTE_LSP_FSM::WaitEqptConf {

 public:

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimeout_t RecvPathTimeout(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnCompleted_t XConnCompleted(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResv_t RecvResv(void* context);

	void after_evRecvResvKo_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathErr_t RecvPathErr(void* context);

	void after_evRecvPathErrKo_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPath_t RecvPath(void* context);

	void after_evRecvPathOk_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTimer_t RecvResvTimer(void* context);

	void after_evRecvResvTimer_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathTear_t SendPathTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTimeout_t RecvResvTimeout(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTear_t RecvResvTear(void* context);

	void after_evRecvResvTearKo_from_virt_WaitEqptConf(void * context);

	void after_evRecvPathKo_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvTear_t SendResvTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTear_t RecvPathTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvErr_t RecvResvErr(void* context);

	void after_evRecvResvErrKo_from_virt_WaitEqptConf(void * context);

	void after_evRecvPathTearKo_from_virt_WaitEqptConf(void * context);

	void after_evRecvResvErrOk_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimer_t RecvPathTimer(void* context);

	void after_evRecvPathTimer_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnErr_t XConnErr(void* context);

	void after_evRecvResvOk_from_virt_WaitEqptConf(void * context);

	void after_evRecvResvOk_from_virt_PathReceived(void * context);

	void after_evSendResv_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathDown_t SendPathDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvDown_t RecvResvDown(void* context);

	void after_evRecvResvDownKo_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathDown_t RecvPathDown(void* context);

	void after_evRecvPathDownKo_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvDown_t SendResvDown(void* context);

};

class Rebuild_i : public fsm::base_G2RSVPTE_LSP_FSM::Rebuild {

 public:

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathErr_t RecvPathErr(void* context);

	void after_evLspRebuild_from_virt_Down(void * context);

	void after_evRecvPathErrKo_from_virt_Rebuild(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathDown_t SendPathDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathDown_t RecvPathDown(void* context);

	void after_evRecvPathDownKo_from_virt_Rebuild(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvDown_t RecvResvDown(void* context);

	void after_evRecvResvDownKo_from_virt_Rebuild(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvDown_t SendResvDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTear_t RecvPathTear(void* context);

	void after_evRecvPathTearKo_from_virt_Rebuild(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnErr_t XConnErr(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnCompleted_t XConnCompleted(void* context);
};

class Installed_i : public fsm::base_G2RSVPTE_LSP_FSM::Installed {

 public:

	void after_evSendConfirm_from_virt_WaitResvConf(void * context);

	void after_evRecvConfirmOk_from_virt_WaitResvConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnCompleted_t XConnCompleted(void* context);

	void after_evXConnCompleted_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathDown_t SendPathDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvConfirm_t RecvConfirm(void* context);

	void after_evRecvConfirmOk_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathDown_t RecvPathDown(void* context);

	void after_evRecvPathDownKo_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPath_t RecvPath(void* context);

	void after_evRecvPathKo_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTear_t RecvResvTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathErr_t RecvPathErr(void* context);

	void after_evRecvPathAlarm_from_virt_Installed(void * context);

	void after_evRecvConfirmKo_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTear_t RecvPathTear(void* context);

	void after_evRecvPathTearKo_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimer_t RecvPathTimer(void* context);

	void after_evRecvPathTimer_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnDown_t XConnDown(void* context);

	void after_evXConnDown_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResv_t RecvResv(void* context);

	void after_evRecvResvOk_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvDown_t RecvResvDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvNotify_t RecvNotify(void* context);

	void after_evRecvNotifyOk_from_virt_Installed(void * context);

	void after_evRecvResvKo_from_virt_Installed(void * context);

	void after_evRecvPathErrKo_from_virt_Installed(void * context);

	void after_evRecvPathOk_from_virt_Installed(void * context);

	void after_evRecvActivateErr_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTimer_t RecvResvTimer(void* context);

	void after_evRecvResvTimer_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnPreempt_t XConnPreempt(void* context);

	void after_evXConnPreempt_from_virt_Installed(void * context);

	void after_evRecvResvDownKo_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvActivate_t RecvActivate(void* context);

	void after_evRecvActivateOk_from_virt_Installed(void * context);

	void after_evRecvResvTearKo_from_virt_Installed(void * context);

	void after_evRecvNotifyKo_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvErr_t RecvResvErr(void* context);

	void after_evRecvResvErrKo_from_virt_Installed(void * context);

	void after_evRecvActivateKo_from_virt_Installed(void * context);

	void after_evRecvResvErrOk_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnErr_t XConnErr(void* context);

	void after_evXConnErr_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvDown_t SendResvDown(void* context);

	void after_evXConnCompleted_from_virt_Rebuild(void * context);

};

class RebuildTearDown_i : public fsm::base_G2RSVPTE_LSP_FSM::RebuildTearDown {

 public:

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathDown_t SendPathDown(void* context);

	void after_evSendPathDown_from_virt_RebuildTearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnCompleted_t XConnCompleted(void* context);

	void after_evXConnCompleted_from_virt_RebuildTearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathErr_t RecvPathErr(void* context);

	void after_evRecvPathErrKo_from_virt_RebuildTearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathTear_t SendPathTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnErr_t XConnErr(void* context);

	void after_evXConnErr_from_virt_RebuildTearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvDown_t RecvResvDown(void* context);

	void after_evRecvResvDownKo_from_virt_RebuildTearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathDown_t RecvPathDown(void* context);

	void after_evRecvPathDownOk_from_virt_RebuildTearDown(void * context);

	void after_evRecvPathDownKo_from_virt_RebuildTearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTear_t RecvResvTear(void* context);

	void after_evRecvResvTearKo_from_virt_RebuildTearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvTear_t SendResvTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTear_t RecvPathTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvErr_t RecvResvErr(void* context);

	void after_evRecvResvErrKo_from_virt_RebuildTearDown(void * context);

	void after_evRecvPathTearKo_from_virt_RebuildTearDown(void * context);

	void after_evRecvResvErrOk_from_virt_RebuildTearDown(void * context);

	void after_evRecvResvDownOk_from_virt_RebuildTearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvDown_t SendResvDown(void* context);

	void after_evSendResvDown_from_virt_RebuildTearDown(void * context);

	void after_evSendPathDown_from_virt_Rebuild(void * context);

	void after_evRecvPathDownOk_from_virt_Rebuild(void * context);

	void after_evRecvResvDownOk_from_virt_Rebuild(void * context);

	void after_evSendResvDown_from_virt_Rebuild(void * context);

};

class PathReceived_i : public fsm::base_G2RSVPTE_LSP_FSM::PathReceived {

 public:

	void after_evRecvPathErrCrankback_from_virt_WaitResv(void * context);

	void after_evXConnErr_from_virt_WaitEqptConf(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimeout_t RecvPathTimeout(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnCompleted_t XConnCompleted(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResv_t RecvResv(void* context);

	void after_evRecvResvKo_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathErr_t RecvPathErr(void* context);

	void after_evRecvPathErrKo_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPath_t RecvPath(void* context);

	void after_evRecvPathOk_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathTear_t SendPathTear(void* context);

	void after_evRecvPathErrCrankback_from_virt_PathReceived(void * context);

	void after_evRecvPathKo_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvTear_t SendResvTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTear_t RecvPathTear(void* context);

	void after_evRecvPathTearKo_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimer_t RecvPathTimer(void* context);

	void after_evRecvPathTimer_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_XConnErr_t XConnErr(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResv_t SendResv(void* context);

	void after_evSendPath_from_virt_Down(void * context);

	void after_evRecvPathOk_from_virt_Down(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvDown_t RecvResvDown(void* context);

	void after_evRecvResvDownKo_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathDown_t RecvPathDown(void* context);

	void after_evRecvPathDownKo_from_virt_PathReceived(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathDown_t SendPathDown(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvDown_t SendResvDown(void* context);

};

class TearDown_i : public fsm::base_G2RSVPTE_LSP_FSM::TearDown {

 public:

	void after_evRecvPathDownOk_from_virt_WaitResvConf(void * context);

	void after_evSendPathDown_from_virt_Installed(void * context);

	void after_evRecvResvDownOk_from_virt_Installed(void * context);

	void after_evRecvPathDownOk_from_virt_Installed(void * context);

	void after_evSendResvDown_from_virt_Installed(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTimeout_t RecvPathTimeout(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathDown_t SendPathDown(void* context);

	void after_evSendPathDown_from_virt_TearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathErr_t RecvPathErr(void* context);

	void after_evRecvPathErrKo_from_virt_TearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPathTear_t SendPathTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvDown_t RecvResvDown(void* context);

	void after_evRecvResvDownKo_from_virt_TearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathDown_t RecvPathDown(void* context);

	void after_evRecvPathDownOk_from_virt_TearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTimeout_t RecvResvTimeout(void* context);

	void after_evRecvPathDownKo_from_virt_TearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvTear_t RecvResvTear(void* context);

	void after_evRecvResvTearKo_from_virt_TearDown(void * context);

	void after_evRecvPathAlarm_from_virt_TearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvTear_t SendResvTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPathTear_t RecvPathTear(void* context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvResvErr_t RecvResvErr(void* context);

	void after_evRecvResvErrKo_from_virt_TearDown(void * context);

	void after_evRecvPathTearKo_from_virt_TearDown(void * context);

	void after_evRecvResvErrOk_from_virt_TearDown(void * context);

	void after_evRecvResvDownOk_from_virt_TearDown(void * context);

	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendResvDown_t SendResvDown(void* context);

	void after_evSendResvDown_from_virt_TearDown(void * context);

	void after_evSendPathDown_from_virt_WaitResvConf(void * context);

	void after_evSendResvDown_from_virt_WaitResvConf(void * context);

	void after_evRecvResvDownOk_from_virt_WaitResvConf(void * context);

	void after_evSendPathDown_from_virt_WaitEqptConf(void * context);

	void after_evRecvPathDownOk_from_virt_WaitEqptConf(void * context);

	void after_evSendResvDown_from_virt_WaitEqptConf(void * context);

	void after_evRecvResvDownOk_from_virt_WaitEqptConf(void * context);

	void after_evSendPathDown_from_virt_PathReceived(void * context);

	void after_evRecvPathDownOk_from_virt_PathReceived(void * context);

	void after_evSendResvDown_from_virt_PathReceived(void * context);

	void after_evRecvResvDownOk_from_virt_PathReceived(void * context);

	void after_evSendPathDown_from_virt_WaitResv(void * context);

	void after_evRecvPathDownOk_from_virt_WaitResv(void * context);

	void after_evSendResvDown_from_virt_WaitResv(void * context);

	void after_evRecvResvDownOk_from_virt_WaitResv(void * context);

};

class Down_i : public fsm::base_G2RSVPTE_LSP_FSM::Down {

 public:
	void after_evSendPathTear_from_virt_WaitResvConf(void * context);
	void after_evRecvResvTearOk_from_virt_WaitResvConf(void * context);
	void after_evRecvPathAlarm_from_virt_WaitResvConf(void * context);
	void after_evSendResvTear_from_virt_WaitResvConf(void * context);
	void after_evRecvPathTearOk_from_virt_WaitResvConf(void * context);
	void after_evRecvPathErrOk_from_virt_WaitResvConf(void * context);
	void after_evRecvPathTimeout_from_virt_WaitResv(void * context);
	void after_evSendPathTear_from_virt_WaitResv(void * context);
	void after_evRecvResvVeryKo_from_virt_WaitResv(void * context);
	void after_evRecvResvTearOk_from_virt_WaitResv(void * context);
	void after_evRecvPathAlarm_from_virt_WaitResv(void * context);
	void after_evSendResvTear_from_virt_WaitResv(void * context);
	void after_evRecvPathTearOk_from_virt_WaitResv(void * context);
	void after_evRecvPathErrOk_from_virt_WaitResv(void * context);
	void after_evRecvPathTimeout_from_virt_WaitEqptConf(void * context);
	void after_evSendPathTear_from_virt_WaitEqptConf(void * context);
	void after_evRecvResvTimeout_from_virt_WaitEqptConf(void * context);
	void after_evRecvResvVeryKo_from_virt_WaitEqptConf(void * context);
	void after_evRecvResvTearOk_from_virt_WaitEqptConf(void * context);
	void after_evSendResvTear_from_virt_WaitEqptConf(void * context);
	void after_evRecvPathTearOk_from_virt_WaitEqptConf(void * context);
	void after_evRecvPathErrOk_from_virt_WaitEqptConf(void * context);
	void after_evRecvResvTearOk_from_virt_Installed(void * context);
	void after_evRecvPathErrOk_from_virt_Installed(void * context);
	void after_evRecvNotifyDown_from_virt_Installed(void * context);
	void after_evRecvResvVeryKo_from_virt_Installed(void * context);
	void after_evRecvPathTearOk_from_virt_Installed(void * context);
	void after_evSendPathTear_from_virt_RebuildTearDown(void * context);
	void after_evRecvResvTearOk_from_virt_RebuildTearDown(void * context);
	void after_evSendResvTear_from_virt_RebuildTearDown(void * context);
	void after_evRecvPathTearOk_from_virt_RebuildTearDown(void * context);
	void after_evRecvPathErrOk_from_virt_RebuildTearDown(void * context);
	void after_evRecvPathErrOk_from_virt_Rebuild(void * context);
        void after_evRecvPathTearOk_from_virt_Rebuild(void * context);
	void after_evRecvPathTimeout_from_virt_PathReceived(void * context);
	void after_evSendPathTear_from_virt_PathReceived(void * context);
	void after_evSendResvTear_from_virt_PathReceived(void * context);
	void after_evRecvPathTearOk_from_virt_PathReceived(void * context);
	void after_evRecvPathErrOk_from_virt_PathReceived(void * context);
	void after_evXConnErr_from_virt_PathReceived(void * context);
	void after_evRecvPathTimeout_from_virt_TearDown(void * context);
	void after_evSendPathTear_from_virt_TearDown(void * context);
	void after_evRecvResvTimeout_from_virt_TearDown(void * context);
	void after_evRecvResvTearOk_from_virt_TearDown(void * context);
	void after_evSendResvTear_from_virt_TearDown(void * context);
	void after_evRecvPathTearOk_from_virt_TearDown(void * context);
	void after_evRecvPathErrOk_from_virt_TearDown(void * context);
	void after_evXConnErr_from_virt_Rebuild(void * context);
	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_SendPath_t SendPath(void* context);
	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_RecvPath_t RecvPath(void* context);
	fsm::base_G2RSVPTE_LSP_FSM::nextEvFor_LspRebuild_t LspRebuild(void* context);
	void after_evRecvPathKo_from_virt_Down(void * context);

 private:
};

class virt_WaitResvConf_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_WaitResvConf {

 public:

	void after_RecvResv_from_WaitResvConf(void * context);

	bool evRecvResvKo(void* context);

	void after_RecvPathErr_from_WaitResvConf(void * context);

	bool evRecvPathErrKo(void* context);

	void after_RecvPath_from_WaitResvConf(void * context);

	bool evRecvPathOk(void* context);

	void after_RecvResvTimer_from_WaitResvConf(void * context);

	bool evRecvResvTimer(void* context);

	void after_XConnPreempt_from_WaitResvConf(void * context);

	bool evXConnPreempt(void* context);

	void after_SendPathTear_from_WaitResvConf(void * context);

	bool evSendPathTear(void* context);

	void after_SendConfirm_from_WaitResvConf(void * context);

	bool evSendConfirm(void* context);

	void after_RecvConfirm_from_WaitResvConf(void * context);

	bool evRecvConfirmOk(void* context);

	void after_RecvPathDown_from_WaitResvConf(void * context);

	bool evRecvPathDownOk(void* context);

	bool evRecvPathDownKo(void* context);

	void after_RecvResvTear_from_WaitResvConf(void * context);

	bool evRecvResvTearKo(void* context);

	bool evRecvPathKo(void* context);

	bool evRecvResvTearOk(void* context);

	bool evRecvConfirmKo(void* context);

	bool evRecvPathAlarm(void* context);

	void after_SendResvTear_from_WaitResvConf(void * context);

	bool evSendResvTear(void* context);

	void after_RecvResvErr_from_WaitResvConf(void * context);

	bool evRecvResvErrKo(void* context);

	void after_RecvPathTear_from_WaitResvConf(void * context);

	bool evRecvPathTearOk(void* context);

	bool evRecvPathTearKo(void* context);

	bool evRecvResvErrOk(void* context);

	void after_RecvPathTimer_from_WaitResvConf(void * context);

	bool evRecvPathTimer(void* context);

	bool evRecvResvOk(void* context);

	bool evRecvPathErrOk(void* context);

	void after_SendPathDown_from_WaitResvConf(void * context);

	bool evSendPathDown(void* context);

	void after_RecvResvDown_from_WaitResvConf(void * context);

	bool evRecvResvDownKo(void* context);

	bool evRecvResvDownOk(void* context);

	void after_SendResvDown_from_WaitResvConf(void * context);

	bool evSendResvDown(void* context);

};

class virt_WaitResv_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_WaitResv {

 public:

	void after_RecvPathTimeout_from_WaitResv(void * context);

	bool evRecvPathTimeout(void* context);

	void after_RecvResv_from_WaitResv(void * context);

	bool evRecvResvKo(void* context);

	void after_RecvPathErr_from_WaitResv(void * context);

	bool evRecvPathErrKo(void* context);

	void after_RecvPath_from_WaitResv(void * context);

	bool evRecvPathOk(void* context);

	void after_XConnPreempt_from_WaitResv(void * context);

	bool evXConnPreempt(void* context);

	void after_SendPathTear_from_WaitResv(void * context);

	bool evSendPathTear(void* context);

	bool evRecvResvVeryKo(void* context);

	void after_RecvResvTear_from_WaitResv(void * context);

	bool evRecvResvTearKo(void* context);

	bool evRecvPathErrCrankback(void* context);

	bool evRecvPathKo(void* context);

	bool evRecvResvTearOk(void* context);

	bool evRecvPathAlarm(void* context);

	void after_SendResvTear_from_WaitResv(void * context);

	bool evSendResvTear(void* context);

	void after_RecvPathTear_from_WaitResv(void * context);

	bool evRecvPathTearOk(void* context);

	bool evRecvPathTearKo(void* context);

	void after_RecvPathTimer_from_WaitResv(void * context);

	bool evRecvPathTimer(void* context);

	bool evRecvPathErrOk(void* context);

	bool evRecvResvOk(void* context);

	void after_SendResv_from_WaitResv(void * context);

	bool evSendResv(void* context);

	void after_SendPathDown_from_WaitResv(void * context);

	bool evSendPathDown(void* context);

	void after_RecvPathDown_from_WaitResv(void * context);

	bool evRecvPathDownOk(void* context);

	bool evRecvPathDownKo(void* context);

	bool evRecvResvDownKo(void* context);

	void after_SendResvDown_from_WaitResv(void * context);

	bool evSendResvDown(void* context);

	void after_RecvResvDown_from_WaitResv(void * context);

	bool evRecvResvDownOk(void* context);

};

class virt_WaitEqptConf_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_WaitEqptConf {

 public:

	void after_RecvPathTimeout_from_WaitEqptConf(void * context);

	bool evRecvPathTimeout(void* context);

	void after_XConnCompleted_from_WaitEqptConf(void * context);

	bool evXConnCompleted(void* context);

	void after_RecvResv_from_WaitEqptConf(void * context);

	bool evRecvResvKo(void* context);

	void after_RecvPathErr_from_WaitEqptConf(void * context);

	bool evRecvPathErrKo(void* context);

	void after_RecvPath_from_WaitEqptConf(void * context);

	bool evRecvPathOk(void* context);

	void after_RecvResvTimer_from_WaitEqptConf(void * context);

	bool evRecvResvTimer(void* context);

	void after_SendPathTear_from_WaitEqptConf(void * context);

	bool evSendPathTear(void* context);

	void after_RecvResvTimeout_from_WaitEqptConf(void * context);

	bool evRecvResvTimeout(void* context);

	bool evRecvResvVeryKo(void* context);

	void after_RecvResvTear_from_WaitEqptConf(void * context);

	bool evRecvResvTearKo(void* context);

	bool evRecvPathKo(void* context);

	bool evRecvResvTearOk(void* context);

	void after_SendResvTear_from_WaitEqptConf(void * context);

	bool evSendResvTear(void* context);

	void after_RecvPathTear_from_WaitEqptConf(void * context);

	bool evRecvPathTearOk(void* context);

	void after_RecvResvErr_from_WaitEqptConf(void * context);

	bool evRecvResvErrKo(void* context);

	bool evRecvPathTearKo(void* context);

	bool evRecvResvErrOk(void* context);

	void after_RecvPathTimer_from_WaitEqptConf(void * context);

	bool evRecvPathTimer(void* context);

	void after_XConnErr_from_WaitEqptConf(void * context);

	bool evXConnErr(void* context);

	bool evRecvPathErrOk(void* context);

	bool evRecvResvOk(void* context);

	void after_SendPathDown_from_WaitEqptConf(void * context);

	bool evSendPathDown(void* context);

	void after_RecvResvDown_from_WaitEqptConf(void * context);

	bool evRecvResvDownKo(void* context);

	bool evRecvResvDownOk(void* context);

	void after_RecvPathDown_from_WaitEqptConf(void * context);

	bool evRecvPathDownOk(void* context);

	bool evRecvPathDownKo(void* context);

	void after_SendResvDown_from_WaitEqptConf(void * context);

	bool evSendResvDown(void* context);

};

class virt_Installed_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_Installed {

 public:

	void after_XConnCompleted_from_Installed(void * context);

	bool evXConnCompleted(void* context);

	void after_SendPathDown_from_Installed(void * context);

	bool evSendPathDown(void* context);

	void after_RecvConfirm_from_Installed(void * context);

	bool evRecvConfirmOk(void* context);

	void after_RecvPathDown_from_Installed(void * context);

	bool evRecvPathDownKo(void* context);

	void after_RecvPath_from_Installed(void * context);

	bool evRecvPathKo(void* context);

	void after_RecvResvTear_from_Installed(void * context);

	bool evRecvResvTearOk(void* context);

	void after_RecvPathErr_from_Installed(void * context);

	bool evRecvPathAlarm(void* context);

	bool evRecvConfirmKo(void* context);

	void after_RecvPathTear_from_Installed(void * context);

	bool evRecvPathTearKo(void* context);

	void after_RecvPathTimer_from_Installed(void * context);

	bool evRecvPathTimer(void* context);

	void after_XConnDown_from_Installed(void * context);

	bool evXConnDown(void* context);

	bool evRecvPathErrOk(void* context);

	void after_RecvResv_from_Installed(void * context);

	bool evRecvResvOk(void* context);

	void after_RecvResvDown_from_Installed(void * context);

	bool evRecvResvDownOk(void* context);

	void after_RecvNotify_from_Installed(void * context);

	bool evRecvNotifyOk(void* context);

	bool evRecvResvKo(void* context);

	bool evRecvNotifyDown(void* context);

	bool evRecvPathErrKo(void* context);

	bool evRecvPathOk(void* context);

	bool evRecvActivateErr(void* context);

	void after_RecvResvTimer_from_Installed(void * context);

	bool evRecvResvTimer(void* context);

	void after_XConnPreempt_from_Installed(void * context);

	bool evXConnPreempt(void* context);

	bool evRecvResvDownKo(void* context);

	void after_RecvActivate_from_Installed(void * context);

	bool evRecvActivateOk(void* context);

	bool evRecvPathDownOk(void* context);

	bool evRecvResvVeryKo(void* context);

	bool evRecvResvTearKo(void* context);

	bool evRecvNotifyKo(void* context);

	bool evRecvPathTearOk(void* context);

	void after_RecvResvErr_from_Installed(void * context);

	bool evRecvResvErrKo(void* context);

	bool evRecvActivateKo(void* context);

	bool evRecvResvErrOk(void* context);

	void after_XConnErr_from_Installed(void * context);

	bool evXConnErr(void* context);

	void after_SendResvDown_from_Installed(void * context);

	bool evSendResvDown(void* context);

};



class virt_PathReceived_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_PathReceived {

 public:

	void after_RecvPathTimeout_from_PathReceived(void * context);

	bool evRecvPathTimeout(void* context);

	void after_XConnCompleted_from_PathReceived(void * context);

	bool evXConnCompleted(void* context);

	void after_RecvResv_from_PathReceived(void * context);

	bool evRecvResvKo(void* context);

	void after_RecvPathErr_from_PathReceived(void * context);

	bool evRecvPathErrKo(void* context);

	void after_RecvPath_from_PathReceived(void * context);

	bool evRecvPathOk(void* context);

	void after_SendPathTear_from_PathReceived(void * context);

	bool evSendPathTear(void* context);

	bool evRecvPathErrCrankback(void* context);

	bool evRecvPathKo(void* context);

	void after_SendResvTear_from_PathReceived(void * context);

	bool evSendResvTear(void* context);

	void after_RecvPathTear_from_PathReceived(void * context);

	bool evRecvPathTearOk(void* context);

	bool evRecvPathTearKo(void* context);

	void after_RecvPathTimer_from_PathReceived(void * context);

	bool evRecvPathTimer(void* context);

	bool evRecvPathErrOk(void* context);

	bool evRecvResvOk(void* context);

	void after_XConnErr_from_PathReceived(void * context);

	bool evXConnErr(void* context);

	void after_SendResv_from_PathReceived(void * context);

	bool evSendResv(void* context);

	void after_SendPathDown_from_PathReceived(void * context);

	bool evSendPathDown(void* context);

	void after_RecvResvDown_from_PathReceived(void * context);

	bool evRecvResvDownKo(void* context);

	bool evRecvResvDownOk(void* context);

	void after_RecvPathDown_from_PathReceived(void * context);

	bool evRecvPathDownOk(void* context);

	bool evRecvPathDownKo(void* context);

	void after_SendResvDown_from_PathReceived(void * context);

	bool evSendResvDown(void* context);

};

class virt_Rebuild_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_Rebuild {

 public:

	void after_RecvPathErr_from_Rebuild(void * context);

	bool evRecvPathErrOk(void* context);

	bool evRecvPathErrKo(void* context);

	void after_SendPathDown_from_Rebuild(void * context);

	bool evSendPathDown(void* context);

	void after_RecvPathDown_from_Rebuild(void * context);

	bool evRecvPathDownOk(void* context);

	bool evRecvPathDownKo(void* context);

	void after_RecvResvDown_from_Rebuild(void * context);

	bool evRecvResvDownOk(void* context);

	bool evRecvResvDownKo(void* context);

	void after_SendResvDown_from_Rebuild(void * context);

	bool evSendResvDown(void* context);

	void after_RecvPathTear_from_Rebuild(void * context);

	bool evRecvPathTearOk(void* context);

	bool evRecvPathTearKo(void* context);

        void after_XConnCompleted_from_Rebuild(void * context);

        bool evXConnCompleted(void* context);

        void after_XConnErr_from_Rebuild(void * context);

        bool evXConnErr(void* context);

};


class virt_TearDown_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_TearDown {

 public:

	void after_RecvPathTimeout_from_TearDown(void * context);

	bool evRecvPathTimeout(void* context);

	void after_SendPathDown_from_TearDown(void * context);

	bool evSendPathDown(void* context);

	void after_RecvPathErr_from_TearDown(void * context);

	bool evRecvPathErrKo(void* context);

	void after_SendPathTear_from_TearDown(void * context);

	bool evSendPathTear(void* context);

	void after_RecvResvDown_from_TearDown(void * context);

	bool evRecvResvDownKo(void* context);

	void after_RecvPathDown_from_TearDown(void * context);

	bool evRecvPathDownOk(void* context);

	void after_RecvResvTimeout_from_TearDown(void * context);

	bool evRecvResvTimeout(void* context);

	bool evRecvPathDownKo(void* context);

	void after_RecvResvTear_from_TearDown(void * context);

	bool evRecvResvTearKo(void* context);

	bool evRecvResvTearOk(void* context);

	bool evRecvPathAlarm(void* context);

	void after_SendResvTear_from_TearDown(void * context);

	bool evSendResvTear(void* context);

	void after_RecvPathTear_from_TearDown(void * context);

	bool evRecvPathTearOk(void* context);

	void after_RecvResvErr_from_TearDown(void * context);

	bool evRecvResvErrKo(void* context);

	bool evRecvPathTearKo(void* context);

	bool evRecvResvErrOk(void* context);

	bool evRecvPathErrOk(void* context);

	bool evRecvResvDownOk(void* context);

	void after_SendResvDown_from_TearDown(void * context);

	bool evSendResvDown(void* context);

};

class virt_RebuildTearDown_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_RebuildTearDown {

 public:

	void after_SendPathDown_from_RebuildTearDown(void * context);

	bool evSendPathDown(void* context);

	void after_XConnCompleted_from_RebuildTearDown(void * context);

	bool evXConnCompleted(void* context);

	void after_RecvPathErr_from_RebuildTearDown(void * context);

	bool evRecvPathErrKo(void* context);

	void after_SendPathTear_from_RebuildTearDown(void * context);

	bool evSendPathTear(void* context);

	void after_XConnErr_from_RebuildTearDown(void * context);

	bool evXConnErr(void* context);

	void after_RecvResvDown_from_RebuildTearDown(void * context);

	bool evRecvResvDownKo(void* context);

	void after_RecvPathDown_from_RebuildTearDown(void * context);

	bool evRecvPathDownOk(void* context);

	bool evRecvPathDownKo(void* context);

	void after_RecvResvTear_from_RebuildTearDown(void * context);

	bool evRecvResvTearKo(void* context);

	bool evRecvResvTearOk(void* context);

	void after_SendResvTear_from_RebuildTearDown(void * context);

	bool evSendResvTear(void* context);

	void after_RecvPathTear_from_RebuildTearDown(void * context);

	bool evRecvPathTearOk(void* context);

	void after_RecvResvErr_from_RebuildTearDown(void * context);

	bool evRecvResvErrKo(void* context);

	bool evRecvPathTearKo(void* context);

	bool evRecvResvErrOk(void* context);

	bool evRecvPathErrOk(void* context);

	bool evRecvResvDownOk(void* context);

	void after_SendResvDown_from_RebuildTearDown(void * context);

	bool evSendResvDown(void* context);

};

class virt_Down_i : public fsm::base_G2RSVPTE_LSP_FSM::virt_Down {

 public:
	void after_LspRebuild_from_Down(void * context);

	bool evLspRebuild(void* context);

	void after_SendPath_from_Down(void * context);

	bool evSendPath(void* context);

	void after_RecvPath_from_Down(void * context);

	bool evRecvPathOk(void* context);

	bool evRecvPathKo(void* context);
};


#endif // G2RSVPTE_LSP_H
