/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef G2RSVPTE_MESSAGE_CONSTANTS_H
#define G2RSVPTE_MESSAGE_CONSTANTS_H

#define G2RSVP_CLASS_SESSION                    1
#define  CTYPE_SESSION_IPV4                     1
#define  CTYPE_SESSION_IPV6                     2
#define  CTYPE_SESSION_LSP_TUNNEL_IPV4          7
#define  CTYPE_SESSION_LSP_TUNNEL_IPV6          8
#define  CTYPE_SESSION_UNI_IPV4                11

#define G2RSVP_CLASS_RSVP_HOP                   3
#define  CTYPE_RSVP_HOP_IPV4                    1
#define  CTYPE_RSVP_HOP_IPV6                    2
#define  CTYPE_RSVP_HOP_IF_ID_IPV4              3
#define  CTYPE_RSVP_HOP_IF_ID_IPV6              4
#define   IF_ID_TLV_IPV4                        1
#define   IF_ID_TLV_IPV4_LEN                    8 //TLV length
#define   IF_ID_TLV_IPV6                        2
#define   IF_ID_TLV_IPV6_LEN                   20 //TLV length
#define   IF_ID_TLV_IF_INDEX                    3
#define   IF_ID_TLV_IF_INDEX_LEN               12 //TLV length
#define   IF_ID_TLV_COMP_IF_DOWN                4
#define   IF_ID_TLV_COMP_IF_DOWN_LEN           12 //TLV length
#define   IF_ID_TLV_COMP_IF_UP                  5
#define   IF_ID_TLV_COMP_IF_UP_LEN             12 //TLV length
#define   IF_ID_TLV_DOWN_LABEL                  6
#define   IF_ID_TLV_DOWN_LABEL_LEN              8 //TLV length
#define   IF_ID_TLV_UP_LABEL                    7
#define   IF_ID_TLV_UP_LABEL_LEN                8 //TLV length

#define G2RSVP_CLASS_INTEGRITY			4
#define  CTYPE_INTEGRITY			1

#define G2RSVP_CLASS_TIME_VALUES		5
#define  CTYPE_TIME_VALUES			1

#define G2RSVP_CLASS_ERROR_SPEC			6
#define  CTYPE_ERROR_SPEC_IPV4			1
#define  CTYPE_ERROR_SPEC_IPV6			2
#define  CTYPE_ERROR_SPEC_IF_ID_IPV4		3
#define  CTYPE_ERROR_SPEC_IF_ID_IPV6		4

#define G2RSVP_CLASS_SCOPE			7
#define  CTYPE_IPV4_SCOPE			1
#define  CTYPE_IPV6_SCOPE			2

#define G2RSVP_CLASS_STYLE			8
#define  CTYPE_STYLE				1

#define G2RSVP_CLASS_FLOWSPEC			9
#define  CTYPE_RESERVED_FLOWSPEC		1
#define  CTYPE_INT_SERV_FLOWSPEC		2
#define   CONTROLLED_LOAD_SERVICE               5
#define   GUARANTEED_SERVICE                    2
#define  CTYPE_LSP_TUNNEL_IPV4			7
#define  CTYPE_LSP_TUNNEL_IPV6			8

#define G2RSVP_CLASS_FILTER_SPEC	       10
#define  CTYPE_IPV4_FILTER_SPEC			1
#define  CTYPE_IPV6_FILTER_SPEC			2
#define  CTYPE_FLOW_LABEL_FILTER_SPEC		3
#define  CTYPE_LSP_IPV4_FILTER_SPEC             7
#define  CTYPE_LSP_IPV6_FILTER_SPEC             8

#define G2RSVP_CLASS_SENDER_TEMPLATE	       11
#define  CTYPE_IPV4_SENDER_TEMPLATE		1
#define  CTYPE_IPV6_SENDER_TEMPLATE		2
#define  CTYPE_FLOW_LABEL_SENDER_TEMPLATE	3
#define  CTYPE_LSP_IPV4_SENDER_TEMPLATE		7
#define  CTYPE_LSP_IPV6_SENDER_TEMPLATE		8

#define	G2RSVP_CLASS_SENDER_TSPEC	       12
#define  CTYPE_SENDER_TSPEC			2

#define G2RSVP_CLASS_ADSPEC		       13
#define  CTYPE_ADSPEC				2

#define G2RSVP_CLASS_POLICY		       14
#define  CTYPE_POLICY				1
#define   PTYPE_PHOSPHORUS_AUTHZ_TOKEN      54000

#define G2RSVP_CLASS_RESV_CONFIRM	       15
#define  CTYPE_RESVCONF_IPV4			1
#define  CTYPE_RESVCONF_IPV6			2

#define G2RSVP_CLASS_LABEL		       16
#define  CTYPE_LABEL                            1
#define  CTYPE_GENERALISED_LABEL		2
#define  CTYPE_WBS_LABEL			3

#define G2RSVP_CLASS_LABEL_REQ		       19
#define  CTYPE_GENERALISED_LABEL_REQ		4

#define G2RSVP_CLASS_EXPLICIT_ROUTE	       20
#define  CTYPE_ERO				1
#define   IPV4_PREF_SUBOBJECT			1
#define   IPV4_PREF_SUBOBJECT_LEN		8 //ERO subObj length
#define   IPV6_PREF_SUBOBJECT			2
#define   IPV6_PREF_SUBOBJECT_LEN	       20 //ERO subObj length
#define   LABEL_ERO_SUBOBJECT			3
#define   LABEL_ERO_SUBOBJECT_LEN		8 //ERO subObj length
						  // Label has variable len ???
#define   UNNUM_LINK_SUBOBJECT			4
#define   UNNUM_LINK_SUBOBJECT_LEN	       12 //ERO subObj length
#define   AS_SUBOBJECT			       32
#define   AS_SUBOBJECT_LEN			4 //ERO subObj length

#define	G2RSVP_CLASS_RECORDED_ROUTE	       21
#define  CTYPE_RECORDED_ROUTE			1
#define   IPV4_ADDR_SUBOBJ			1
#define   IPV4_ADDR_SUBOBJ_LEN			8 //RRO subObj length
#define   IPV6_ADDR_SUBOBJ			2
#define   IPV6_ADDR_SUBOBJ_LEN		       20 //RRO subObj length
#define   LABEL_SUBOBJ				3
#define   LABEL_SUBOBJ_LEN			8 //RRO subObj length variable?
#define   UNNUM_LINK_SUBOBJ                     4
#define   UNNUM_LINK_SUBOBJ_LEN                12 //RRO subObj length

#define G2RSVP_CLASS_HELLO		       22
#define  CTYPE_HELLO				1
#define  CTYPE_HELLO_ACK			2

#define G2RSVP_CLASS_MESSAGE_ID		       23
#define  CTYPE_MESSAGE_ID			1

#define G2RSVP_CLASS_MESSAGE_ID_ACK_NACK       24
#define  CTYPE_MESSAGE_ID_ACK			1
#define  CTYPE_MESSAGE_ID_NACK			2

#define G2RSVP_CLASS_MESSAGE_ID_LIST	       25
#define  CTYPE_MSG_ID_LIST			1
#define  CTYPE_MSG_ID_IPV4_SOURCE_LIST		2
#define  CTYPE_MSG_ID_IPV6_SOURCE_LIST		3
#define  CTYPE_MSG_ID_IPV4_MCAST_LIST		4
#define  CTYPE_MSG_ID_IPV6_MCAST_LIST		5

#define G2RSVP_CLASS_RECOVERY_LABEL	       34
//#define  CTYPE_RECOVERY_LABEL                 1
#define  CTYPE_RECOVERY_GENERALISED_LABEL       2
//#define  CTYPE_RECOVERY_WBS_LABEL             3

#define G2RSVP_CLASS_UPSTREAM_LABEL            35
#define  CTYPE_UPSTREAM_LABEL                   1
#define  CTYPE_UPSTREAM_GENERALISED_LABEL       2
#define  CTYPE_UPSTREAM_WBS_LABEL               3

#define G2RSVP_CLASS_LABEL_SET		       36
#define  CTYPE_LABEL_SET			1

#define G2RSVP_CLASS_PROTECTION		       37
#define  CTYPE_PROTECTION			1

#define G2RSVP_CLASS_SUGGESTED_LABEL	      129
//#define  CTYPE_SUGGESTED_LABEL                1
#define  CTYPE_SUGGESTED_GENERALISED_LABEL      2
//#define  CTYPE_SUGGESTED_WBS_LABEL            3

#define G2RSVP_CLASS_ACCEPTABLE_LABEL_SET     130
#define  CTYPE_ACCEPTABLE_LABEL_SET		1

#define G2RSVP_CLASS_RESTARTCAP		      131
#define  CTYPE_RESTART_CAP			1

#define G2RSVP_CLASS_NOTIFY_REQUEST	      195
#define  CTYPE_IPV4_NOTIFY_REQUEST		1
#define  CTYPE_IPV6_NOTIFY_REQUEST		2

#define G2RSVP_CLASS_ADMIN_STATUS	      196
#define  CTYPE_ADMIN_STATUS			1

#define G2RSVP_CLASS_LSP_ATTRIBUTES	      197
#define  CTYPE_LSP_ATTRIBUTES			1
#define   TLV_LSP_ATTR                          1
#define   TLV_LSP_ATTR_LEN                      8 // TLV length

#define G2RSVP_CLASS_SESSION_ATTRIBUTE	      207
#define  CTYPE_SESSION_ATTRIBUTE_LSP_TUNNEL	7
#define  CTYPE_SESSION_ATTRIBUTE_LSP_TUNNEL_RA	1

#define G2RSVP_CLASS_CALL_OPS		      228
#define  CTYPE_CALL_OPS				1

#define G2RSVP_CLASS_GENERALIZED_UNI	      229
#define  CTYPE_GENERALIZED_UNI			1
// OIF UNI Source TNA sub-object
#define   TYPE_SRC_TNA				1
#define   SUBTYPE_IPv4_SRC_TNA			1
#define   SUBTYPE_IPv6_SRC_TNA			2
#define   SUBTYPE_NSAP_SRC_TNA			3
// OIF UNI Destination TNA sub-object
#define   TYPE_DST_TNA				2
#define   SUBTYPE_IPv4_DST_TNA			1
#define   SUBTYPE_IPv6_DST_TNA			2
#define   SUBTYPE_NSAP_DST_TNA			3
// OIF UNI Diversity sub-object
#define   TYPE_DIVERSITY			3
#define   SUBTYPE_DIVERSITY			1
// OIF UNI/ASON G.7713.2 Egress Label sub-object
#define   TYPE_EGR_LABEL			4
#define   SUBTYPE_EGR_LABEL			1
#define   SUBTYPE_EGR_SPC_LABEL			2
// OIF UNI Service Level sub-object
#define   TYPE_SERVICE_LVL			5
#define   SUBTYPE_SERVICE_LVL			1

#define G2RSVP_CLASS_CALL_ID		      230
#define CTYPE_CALL_ID_OPERATOR_SPECIFIC		1
#define CTYPE_CALL_ID_GLOBALLY_UNIQUE		2
#define CTYPE_CALL_ID_NULL                 	3

#define G2RSVP_CLASS_GNS_CALL_EXT	      248
#define  CTYPE_GNS_CALL				1

#define G2RSVP_CLASS_GNS_UNI		      249
#define  CTYPE_GNS_UNI				1
// Grid Application sub-object
#define   TYPE_APPLICATION			1
#define   SUBTYPE_APPLICATION			1
// Grid Candidate Hosts sub-object
#define   TYPE_CANDIDATE_HOSTS			2
#define   SUBTYPE_IPv4_CANDIDATE_HOSTS		1
#define   SUBTYPE_IPv6_CANDIDATE_HOSTS		2
#define   SUBTYPE_NSAP_CANDIDATE_HOSTS		3
// Grid File System Resources sub-object
#define   TYPE_FILE_SYSTEM_RES			3
#define   SUBTYPE_FILE_SYSTEM_RES		1
// Grid System Capabilities sub-object
#define   TYPE_SYSTEM_CAPS			4
#define   SUBTYPE_SYSTEM_CAPS			1
// Grid Individual CPU Speed sub-object
#define   TYPE_INDIV_CPU_SPEED			5
#define   SUBTYPE_INDIV_CPU_SPEED		1
// Grid Individual CPU Time sub-object
#define   TYPE_INDIV_CPU_TIME			6
#define   SUBTYPE_INDIV_CPU_TIME		1
// Grid Individual CPU Count sub-object
#define   TYPE_INDIV_CPU_COUNT			7
#define   SUBTYPE_INDIV_CPU_COUNT		1
// Grid Individual Network Bandwidth sub-object
#define   TYPE_INDIV_NET_BW			8
#define   SUBTYPE_INDIV_NET_BW			1
// Grid Individual Physical Memory sub-object
#define   TYPE_INDIV_PHY_MEM			9
#define   SUBTYPE_INDIV_PHY_MEM			1
// Grid Individual Virtual Memory sub-object
#define   TYPE_INDIV_VIR_MEM		       10
#define   SUBTYPE_INDIV_VIR_MEM			1
// Grid Individual Disk Space sub-object
#define   TYPE_INDIV_DISK_SPACE		       11
#define   SUBTYPE_INDIV_DISK_SPACE		1
// Grid Total CPU Time sub-object
#define   TYPE_TOTAL_CPU_TIME		       12
#define   SUBTYPE_TOTAL_CPU_TIME		1
// Grid Total CPU Count sub-object
#define   TYPE_TOTAL_CPU_COUNT		       13
#define   SUBTYPE_TOTAL_CPU_COUNT		1
// Grid Total Physical Memory sub-object
#define   TYPE_TOTAL_PHY_MEM		       14
#define   SUBTYPE_TOTAL_PHY_MEM			1
// Grid Total Virtual Memory sub-object
#define   TYPE_TOTAL_VIR_MEM		       15
#define   SUBTYPE_TOTAL_VIR_MEM			1
// Grid Total Disk Space sub-object
#define   TYPE_TOTAL_DISK_SPACE		       16
#define   SUBTYPE_TOTAL_DISK_SPACE		1
// Grid Total Resource Count sub-object
#define   TYPE_TOTAL_RES_COUNT		       17
#define   SUBTYPE_TOTAL_RES_COUNT		1
// Grid Data Staging sub-object
#define   TYPE_DATA_STAGING		       18
#define   SUBTYPE_DATA_STAGING			1

#define G2RSVP_CLASS_TIMES                    250
#define  CTYPE_TIMES                            1


#define G2RSVPTE_DEFAULT_IPv4_PREFLEN          32
#define G2RSVPTE_DEFAULT_IPv6_PREFLEN         128

//
// Error Spec Flags
//

#define G2RSVPTE_ERROR_SPEC_FLAG_InPlace			      0x01
#define G2RSVPTE_ERROR_SPEC_FLAG_NotGuilty			      0x02
#define G2RSVPTE_ERROR_SPEC_FLAG_PathStateRemoved		      0x04

//
// Error Spec Codes and SubCodes
//

#define G2RSVPTE_ERROR_SPEC_ZERO                                         0
#    define G2RSVPTE_ERROR_SPEC_VAL_ZERO                                    0

#define G2RSVPTE_ERROR_SPEC_CONFIRM                                      0

#define G2RSVPTE_ERROR_SPEC_ADMISSION_CONTROL                            1
#    define G2RSVPTE_ERROR_SPEC_VAL_ADMISSION_CONTROL_DELAY                 1
#    define G2RSVPTE_ERROR_SPEC_VAL_ADMISSION_CONTROL_BANDWIDTH             2
#    define G2RSVPTE_ERROR_SPEC_VAL_ADMISSION_CONTROL_MTU                   3
#    define G2RSVPTE_ERROR_SPEC_VAL_ADMISSION_CONTROL_LSP                   4
#    define G2RSVPTE_ERROR_SPEC_VAL_ADMISSION_CONTROL_BAD_ASSOC             5

#define G2RSVPTE_ERROR_SPEC_POLICY_CONTROL                               2
// see RFC 2750
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_INFO                     0
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_WARN                     1
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_UNKNOWN                  2
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_REJECT                   3
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_EXCEED                   4
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_PREEMPT                  5
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_EXPIRED                  6
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_REPLACED                 7
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_MERGE                    8
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_PDP                      9
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_SERVER                  10
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_POLICY_DATA_SYNTAX      11
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_POLICY_DATA_INTEGRITY   12
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_POLICY_ELEMENT_SYNTAX   13
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_POLICY_ELEMENT_MISSING  14
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_NO_RESOURCES            15
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_RSVP                    16
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_SERVICE                 17
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_STYLE                   18
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_FLOWSPEC                19
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_HARD_PREEMPTED          20
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_UNAUTHORIZED_SENDER     100
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_UNAUTHORIZED_RECEIVER   101
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_PARTIAL_PREEMPT         102
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_INTER_DOMAIN_FAILURE    103
#    define G2RSVPTE_ERROR_SPEC_VAL_POLICY_CONTROL_INTER_DOMAIN_ER_REJ     104

#define G2RSVPTE_ERROR_SPEC_NO_PATH                                      3

#define G2RSVPTE_ERROR_SPEC_NO_SENDER                                    4

#define G2RSVPTE_ERROR_SPEC_CONFLICTING_STYLE                            5

#define G2RSVPTE_ERROR_SPEC_UNKNOWN_STYLE                                6

#define G2RSVPTE_ERROR_SPEC_CONFLICTING_DESTINATION_PORTS                7

#define G2RSVPTE_ERROR_SPEC_CONFLICTING_SENDER_PORTS                     8

#define G2RSVPTE_ERROR_SPEC_SERVICE_PREEMPTED                           12

#define G2RSVPTE_ERROR_SPEC_UNKNOWN_CLASS                               13

#define G2RSVPTE_ERROR_SPEC_UNKNOWN_CTYPE                               14

#define G2RSVPTE_ERROR_SPEC_TRAFFIC_CONTROL                             21
#    define G2RSVPTE_ERROR_SPEC_VAL_TRAFFIC_CONTROL_SERVICE_CONFLICT        1
#    define G2RSVPTE_ERROR_SPEC_VAL_TRAFFIC_CONTROL_SERVICE_UNSUPPORTED     2
#    define G2RSVPTE_ERROR_SPEC_VAL_TRAFFIC_CONTROL_BAD_FLOWSPEC            3
#    define G2RSVPTE_ERROR_SPEC_VAL_TRAFFIC_CONTROL_BAD_TSPEC               4
#    define G2RSVPTE_ERROR_SPEC_VAL_TRAFFIC_CONTROL_BAD_ADSPEC              5

#define G2RSVPTE_ERROR_SPEC_TC_SYSTEM                                   22

#define G2RSVPTE_ERROR_SPEC_SYSTEM                                      23

#define G2RSVPTE_ERROR_SPEC_ROUTING                                     24
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_BAD_ERO                      1
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_BAD_STRICT_NODE              2
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_BAD_LOOSE_NODE               3
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_BAD_INITIAL_SUBOBJECT        4
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_NO_ROUTE                     5
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNACCEPTABLE_LABEL           6
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_RRO_LOOP_DETECTED            7
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_NON_RSVP_ROUTER_DETECTED     8
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_LABEL_ALLOCATION_FAILURE     9
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNSUPPORTED_L3PID           10
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_LABEL_SET                   11
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_SWITCHING_TYPE              12
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNSUPPORTED_ENCODING        14
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNSUPPORTED_LINK_PROTECTION 15
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNKNOWN_INTERFACE_INDEX     16
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNSUPPORTED_LSP_PROTECTION  17
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_PROTECTION_NOT_APPL         18
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_BAD_PRIMARY_PATH_ROUTE      19
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_PRIMARY_PATH_ROUTE_NOT_APPL 20
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_LSP_PROTECTION_FAILED       21
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_REROUTING_LIMIT_EXCEEDED    22
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNABLE_TO_BRANCH            23
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNSUPPORTED_LSP_INTEGRITY   24
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_P2MP_REMERGE_DETECTED       25
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_P2MP_REMERGE_PARAM_MISMATCH 26
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_ERO_RESULTED_IN_REMERGE     27
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_CONTIGUOS_LSP_UNSUPPORTED   28
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_ERO_CONFLICTS               29
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_STITCHING_UNSOPPORTED       30
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNSUPPORTED_EXCLUDE_ROUTE   64
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_INCONSISTENT_SUBOBJ         65
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_LOCAL_NODE_IN_EXCLUDE_ROUTE 66
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_ROUTE_BLOCKED               67
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_XRO_TOO_COMPLEX             68
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_EXRS_TOO_COMPLEX            69
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_DIVERSITY_NOT_AVAIL        100
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_SERVICE_LEVEL_NOT_AVAIL    101
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_INVALID_CONNECTION_ID      102
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_NO_ROUTE_AVAILABLE         103
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_UNACCEPTABLE_INTERFACE_ID  104
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_INVALID_CALL_ID            105
#    define    G2RSVPTE_ERROR_SPEC_VAL_ROUTING_INVALID_SPC_LABEL          106

#define G2RSVPTE_ERROR_SPEC_NOTIFY                                      25
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_RRO_TOO_LARGE                 1
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_RRO_NOTIFICATION              2
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_LOCALLY_REPAIRED              3
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_CONTROL_CHANNEL_ACTIVE_STATE  4
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_CONTROL_CHANNEL_DEGR_STATE    5
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_PREFERABLE_PATH_EXIST         6
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_LOCAL_LINK_MAINTEINANCE_REQ   7
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_LOCAL_NODE_MAINTEINANCE_REQ   8
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_LSP_FAILURE                   9
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_LSP_RECOVERED                10
#    define    G2RSVPTE_ERROR_SPEC_VAL_NOTIFY_LSP_LOCALLY_FAILED           11

#define G2RSVPTE_ERROR_SPEC_DIFFSERV                                    27
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_UNEXPECTED                  1
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_UNSUPPORTED_PHB             2
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_INVALID_EXP_PHB_MAPPING     3
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_UNSUPPORTED_PSC             4
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_PER_LSP_ALLOCATION_FAILURE  5

#define G2RSVPTE_ERROR_SPEC_DIFFSERV_AWARE_TE                           28
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_AWARE_TE_UNEXPECTED_CTYPE        1
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_AWARE_TE_UNSUPPORTED_CTYPE       2
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_AWARE_TE_INVALID_CTYPE           3
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_AWARE_TE_INVALID_TE_CLASS        4
//#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_AWARE_TE_INVALID_TE_CLASS        5
//#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_AWARE_TE_INVALID_TE_CLASS        6
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_AWARE_TE_PSC_CTYPE_INCONSISTENCY 7
#    define    G2RSVPTE_ERROR_SPEC_VAL_DIFFSERV_AWARE_TE_PHB_CTYPE_INCONSISTENCY 8

#define G2RSVPTE_ERROR_SPEC_UNKNOWN_ATTRIBUTES_TLV                      29

#define G2RSVPTE_ERROR_SPEC_UNKNOWN_ATTRIBUTES_BIT                      30

#define G2RSVPTE_ERROR_SPEC_ALARMS                                      31

#define G2RSVPTE_ERROR_SPEC_CALL_MNGMT                                  32
#    define    G2RSVPTE_ERROR_SPEC_VAL_CALL_MNGMT_CALL_ID_CONTENTION        1
#    define    G2RSVPTE_ERROR_SPEC_VAL_CALL_MNGMT_CONNECTIONS_EXISTS        2
#    define    G2RSVPTE_ERROR_SPEC_VAL_CALL_MNGMT_UNKNOWN_CALL_ID           3
#    define    G2RSVPTE_ERROR_SPEC_VAL_CALL_MNGMT_DUPLICATE_CALL            4

#define G2RSVPTE_MAX_ERROR_CODE_STRING_LEN      256
#define G2RSVPTE_MAX_ERROR_CODE                 106
#define G2RSVPTE_MAX_ERROR_VALUE                32

//
// Default timer values
//

// this is L, should be >= (K + 0.5)*1.5*R (suggested K is 3)
#define G2RSVPTE_DEFAULT_REFRESH_TIMEOUT    6 // to be multiplied by refresh



#endif // G2RSVPTED_MESSAGE_CONSTANTS_H
