/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef  G2RSVPTE_SCNGW_API
#define  G2RSVPTE_SCNGW_API

#include "g2rsvpte_messages.h"

#define G2RSVPTE_MAX_PACKET_SIZE  65535U

typedef struct msg_data {
	RSVP::Message * msg;
	g2mpls_addr_t   src;
	g2mpls_addr_t   dst;
} msg_data_t;

int  init_scngw(adj_type_t adjType, bool tunneled);
void close_scngw(int fd);
int  reconnect_scngw(struct thread *thread);
int  listen_from_scngw(struct thread *thread);
int  send_to_scngw(struct thread *thread);


#ifdef G2RSVPTE2SCNGW_DEBUG

struct rsvpte_header {
	u_char version:4;
	u_char flags:4;
	u_char msg_type;
	u_int16_t check_sum;
	u_char	send_ttl;
	u_char reserved;
	u_int16_t length;
};

int sock_init(void);
int net_packet_read (struct thread *thread);
int send_buffer(const void *   buff, size_t         size,
		struct in_addr src,  struct in_addr dst);
void server_start(void);

#endif // G2RSVPTE2SCNGW_DEBUG

#endif   // G2RSVPTE_SCNGW_API
