//
//  This file is part of phosphorus-g2mpls.
//
//  Copyright (C) 2006, 2007, 2008, 2009 University of Essex.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//  Authors:
//
//  Eduard Escalona       (Univ. of Essex)   <eescal_at_essex.ac.uk>
//



#include "soapBESFactoryBindingProxy.h"
#include "BESFactoryBinding.nsmap"
#include "soapH.h"
#include "soapStub.h"

const char server[] = "localhost:8080";
//const char server[] = "http://packcs-e0.scai.fraunhofer.de/phosphorus-wp2/services/BESFactoryService";

int
main ()
{
    BESFactoryBindingProxy BES;
    std::string temp;
    
    /*char name[255];
    gethostname (name, sizeof(name));
    printf("Hostname = %s\n", name);
    struct in_addr *address_ip4;
    hostent *HostAddress;
    HostAddress = gethostbyname(name); 
    address_ip4 = (in_addr *) HostAddress->h_addr;
    printf("Hostname IP = %s\n", inet_ntoa(address_ip4[0]));*/

    printf("== BES client v0.1 ==\n");
    printf(" 1. Create Activity\n");
    printf(" 2. Terminate Activities\n");
    printf(" 3. Get Activity Status\n");
    printf(" 0. Exit\n");
    temp = "9";
    while  (temp != "0")
    {
        temp = std::cin.get();
        if (temp == "1")
        {
            bes__CreateActivityType *CA = new bes__CreateActivityType;
            bes__CreateActivityResponseType *CAR = new bes__CreateActivityResponseType;
            
            CA->bes__ActivityDocument = new bes__ActivityDocumentType;
            CA->bes__ActivityDocument->jsdl__JobDefinition = new jsdl__JobDefinition_USCOREType;
            CA->bes__ActivityDocument->jsdl__JobDefinition->id = new char[255];
            CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription = new jsdl__JobDescription_USCOREType;
            CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->jsdl__Application = new jsdl__Application_USCOREType;
            CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->jsdl__Application->jsdl__ApplicationName = new char[255];

            CA->bes__ActivityDocument->jsdl__JobDefinition->id = "1.1.1.1";
            CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->jsdl__Application->jsdl__ApplicationName = "KoDaViS";
            CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->net__NetworkAttributes = new net__NetworkAttributesType;
            //CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->net__NetworkAttributes->AddressingType = unicast;
            CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->net__NetworkAttributes->Bandwidth = 1000000;
            CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->net__NetworkAttributes->IngresTNA = "1.1.1.1";
            CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->net__NetworkAttributes->EgresTNA = "2.2.2.2";

            BES.soap_endpoint = server;
            BES.CreateActivity(CA, CAR);

            printf("CAR->ActivityIdentifier->Address->__item = %s\n", CAR->ActivityIdentifier->Address->__item);
            printf("CAR->ActivityIdentifier->ReferenceParameters->__any[0] = %s\n", CAR->ActivityIdentifier->ReferenceParameters->__any[0]);

            delete CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription->jsdl__Application;
            delete CA->bes__ActivityDocument->jsdl__JobDefinition->jsdl__JobDescription;
            delete CA->bes__ActivityDocument->jsdl__JobDefinition;
            delete CA->bes__ActivityDocument;
            delete CA;
            delete CAR;
        }
        else if (temp == "2")
        {
            bes__TerminateActivitiesType *TA = new bes__TerminateActivitiesType;
            bes__TerminateActivitiesResponseType *TAR = new bes__TerminateActivitiesResponseType;
            
            TA->__sizeActivityIdentifier = 1;
            TA->ActivityIdentifier = new wsa__EndpointReferenceType*;
            TA->ActivityIdentifier[0] = new wsa__EndpointReferenceType;
            TA->ActivityIdentifier[0]->Address = new wsa__AttributedURIType;
            TA->ActivityIdentifier[0]->Address->__item = new char[255];
            TA->ActivityIdentifier[0]->Address->__item = "http://localhost:8080";
            TA->ActivityIdentifier[0]->ReferenceParameters  = new wsa__ReferenceParametersType;
            TA->ActivityIdentifier[0]->ReferenceParameters->__size = 1;
            TA->ActivityIdentifier[0]->ReferenceParameters->__any = new char*;
            TA->ActivityIdentifier[0]->ReferenceParameters->__any[0] = new char[255];
            sprintf(TA->ActivityIdentifier[0]->ReferenceParameters->__any[0],
                    "<ph:ID xmlns:ph=\"http://schemas.phosphorus.eu\">1</ph:ID>");

            BES.soap_endpoint = server;
            BES.TerminateActivities(TA, TAR);

            printf("TAR->Response = %s\n", TAR->Response[0]->Cancelled ? "true" : "false");
            printf("TAR->Response[0]->ActivityIdentifier->Address = %s\n",TAR->Response[0]->ActivityIdentifier->Address->__item);
            printf("TAR->Response[0]->ActivityIdentifier->ReferenceParameters = %s", TAR->Response[0]->ActivityIdentifier->ReferenceParameters->__any[0]);

            delete TA->ActivityIdentifier[0]->ReferenceParameters;
            delete TA->ActivityIdentifier[0]->Address;
            delete TA->ActivityIdentifier[0];
            delete TA->ActivityIdentifier;
            delete TA;
            delete TAR;
        }
        else if (temp == "3")
        {
            bes__GetActivityStatusesType *GAS = new bes__GetActivityStatusesType;
            bes__GetActivityStatusesResponseType *GASR = new bes__GetActivityStatusesResponseType;
            
            GAS->__sizeActivityIdentifier = 1;
            GAS->ActivityIdentifier = new wsa__EndpointReferenceType*;
            GAS->ActivityIdentifier[0] = new wsa__EndpointReferenceType;
            GAS->ActivityIdentifier[0]->Address = new wsa__AttributedURIType;
            GAS->ActivityIdentifier[0]->Address->__item = new char[255];
            GAS->ActivityIdentifier[0]->Address->__item = "http://localhost:8080";
            GAS->ActivityIdentifier[0]->ReferenceParameters  = new wsa__ReferenceParametersType;
            GAS->ActivityIdentifier[0]->ReferenceParameters->__size = 1;
            GAS->ActivityIdentifier[0]->ReferenceParameters->__any = new char*;
            GAS->ActivityIdentifier[0]->ReferenceParameters->__any[0] = new char[255];
            sprintf(GAS->ActivityIdentifier[0]->ReferenceParameters->__any[0],
                    "<ph:ID xmlns:ph=\"http://schemas.phosphorus.eu\">1</ph:ID>");

            BES.soap_endpoint = server;
            BES.GetActivityStatuses(GAS, GASR);
            
            if (GASR->Response[0]->bes__ActivityStatus->state ==bes__ActivityStateEnumeration__Running)
            {
                printf("State: Running\n");
            }
            
            delete GAS->ActivityIdentifier[0]->ReferenceParameters;
            delete GAS->ActivityIdentifier[0]->Address;
            delete GAS->ActivityIdentifier[0];
            delete GAS->ActivityIdentifier;            
            delete GAS;
            delete GASR;
        }
        else if (temp == "0")
        {
            return 0;
        }
        else if (temp == "4")
	{
	    
	}
	else
        {
             printf("Wrong option, try again");
        }
    }
    
    return 0;
}
