/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */




#ifndef _ZEBRA_SCNGWS_LRM_H
#define _ZEBRA_SCNGWS_LRM_H

/* Protoypes */
#if !HAVE_OMNIORB
void scngws_lrm_init (void);
#else
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
struct zlist *get_tel_cc_list (void);
struct zlist *get_cc_scnif_list (void);
struct zlist *get_scnif_list (void);
struct zlist *get_tmp_tel_cc_list (void);
struct zlist *get_tmp_cc_scnif_list (void);
struct zlist *get_tmp_scnif_list (void);
void tel_cc_scnif_association_init (void);
void tmp_tel_cc_scnif_association_init (void);
void delete_tmp_associations (void);
struct scnif *scnif_new (void);
struct tel_cc_assoc *tel_cc_new (void);
struct cc_scnif_assoc *cc_scnif_new (void);
int check_cc (u_int32_t cc_id);
int delete_cc_from_tel (u_int32_t id);
int delete_scnif_from_cc (struct in_addr addr);
void delete_tmp_association (void);
void delete_old_associations (void);
void realign_associations (void);
#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* !HAVE_OMNIORB */
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
const char *if_type_string(u_int16_t);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _ZEBRA_SCNGWS_LRM_H*/
