
import sys
import omniORB
from omniORB import CORBA

sys.path.insert(0, '/home/user01/phosphorus-g2mpls/src/pyg2mpls/corbasket')
import Topology.g2mplsTopology as TOPOLOGY
import Topology._GlobalIDL as GLOB
sys.path.pop(0)

addresses = [
#    '192.168.100.8',
#    '192.168.100.9',
#    '192.168.100.10',
#    '192.168.100.11',
    '192.168.100.137',
    '192.168.100.138',
    '192.168.100.139',
]


def itoa(ia):
  '''convert long int to dotted ip address string'''
  r = ia>>24, (ia&0xFF0000)>>16, (ia&0xFF00)>>8, ia&0xFF
  return '.'.join([str(s) for s in r])


def read_topology(ip_addr):
    print '\nGetting topology from g2pcera in %s' % ip_addr

    orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)
    iorfile = '/mnt/g2iors/node-%s/g2mpls_topology.ior' % ip_addr
    ior = file(iorfile, 'r').readline()
    print "ior is", ior

    obj = orb.string_to_object(ior)
    topology = obj._narrow(TOPOLOGY.Info)
    print 'topology is', topology
    if topology is None:
      print "Object reference is not an g2mplsTopology::Info"
      return ''
    
    raw_text = "G2PCERA is %s\n" % ip_addr
    print 'Getting freeJobSlots from Topology\n\n'
    
    jobSlots = {}
    tnas = {}
    
    nodes = topology.nodeGetAll()
    for node in nodes:
        #print itoa(node.id), node.type
	if node.type == GLOB.g2mplsTypes.NODETYPE_GRID:
	    b, info, subnodes = topology.gridSiteGet(node.id)
	    for computingElem in subnodes.compElems:
		compElem = topology.gridCompElemGet(node.id, computingElem.id)[1]
		#print 'Free Job Slots are', compElem.jobsState.freeJobSlots, 'for', itoa(info.peRouterId)
                jobSlots[itoa(info.peRouterId)] = compElem.jobsState.freeJobSlots
	elif node.type == GLOB.g2mplsTypes.NODETYPE_NETWORK:
	    for tna in topology.tnaIdsGetAllFromNode(node.id, False):
                #print "TNA %s is installed on node %s" % ( itoa(tna.tna.ipv4), itoa(tna.node))
		tnas[itoa(tna.node)] = itoa(tna.tna.ipv4)
		
    for peRouter, freeJobSlots in jobSlots.items():
	raw_text += "- in Grid Site with TNA %s there is FreeJobSlots=%s\n" % (tnas[peRouter], freeJobSlots)
	
    return raw_text


def get_freeJobSlotes():
    raw_text = ""
    for addr in addresses:
        try:
            raw_text += read_topology(addr)
        except Exception, e:
            import traceback
            traceback.print_exc()
    print raw_text
    return raw_text

def send_freeJobSlots(addr, raw_text):
    import httplib, urllib
    params = urllib.urlencode({'freeJobSlots': raw_text})
    headers = {"Content-type": "application/x-www-form-urlencoded",
            "Accept": "text/plain"}
    conn = httplib.HTTPConnection("%s:80" % addr)
    conn.request("POST", "/testbed/phosphorus_testbed/fff/test3.php", params, headers)
    response = conn.getresponse()
    data = response.read()
    #print 'http response is', response, data
    conn.close()


if __name__ == '__main__':
    import time
    omniORB.setClientCallTimeout(500)
    while True:
    	text = get_freeJobSlotes()
        try:
            pass
    	    #send_freeJobSlots('150.254.171.133', text)
        except:
            pass
        time.sleep(3)
	break
